<script>
// import modules
  import {scaleLinear, scaleBand} from "d3-scale";
  import {select} from "d3-selection";
  import {axisBottom, axisLeft} from "d3-axis";


  // Dimensions
  const width = 600;
  const height = 300;
  const margin = { top: 10, right: 10, bottom: 30, left: 60 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Array
  const data = [
    { service: "Netflix", viewers: 2.9 },
    { service: "Amazon Prime Video", viewers: 1.3 },
    { service: "Disney+", viewers: 2.1 },
    { service: "Hulu", viewers: 0.9 },
    { service: "Apple TV", viewers: 1.1 },
    { service: "Rakuten", viewers: 0.4 }
  ];

   
  // create the scale
  let xScale=scaleBand().domain(["Netflix","Amazon Prime Video","Disney+","Hulu","Apple TV","Rakuten"]).range([0,innerWidth]).paddingInner(0.05);
  let yScale=scaleLinear().domain([0,3]).range([innerHeight,margin.top]);

  // Create axes
  let xAxis=axisBottom(xScale);
  let yAxis=axisLeft(yScale);

  // Action for axis
  function showAxis_x(g){
      xAxis(select(g))
  }

  function showAxis_y(g){
    yAxis(select(g))
  }
</script>

<!-- setting a viewBox and max-width allows the SVG to shrink but not grow! -->
<svg viewbox="0 0 {width} {height}" style="max-width: {width}px">
  <g transform={`translate(${margin.left},${margin.top})`}>
    <g class='bars' transform={"origin:center rotate(180)"}>
      {#each data as data}
        <rect x={xScale(data.service)+8} y={yScale(data.viewers)} height={yScale(0)-yScale(data.viewers)} width="60"/>
      {/each}
    </g>
  </g>

  <g xAxis use:showAxis_x transform='translate({margin.left-5},{yScale(0)+10})'></g>
  <g yAxis use:showAxis_y transform="translate({margin.left-5},{yScale(3)})"></g>
  <text transform="translate({margin.left-40},{innerHeight/2}) rotate(-90)" text-anchor='middle'>Viewers (Million)</text>
</svg>

<style>
  .bars rect{
    fill: steelblue;
  }

  text {
    font-size: x-small;

    font-family: Verdana, Geneva, Tahoma, sans-serif;
  }
</style>
